"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "i4Context", {
  enumerable: true,
  get: function get() {
    return _api.i4Context;
  }
});
Object.defineProperty(exports, "setContext", {
  enumerable: true,
  get: function get() {
    return _api.setContext;
  }
});
exports.logoutAndForget = exports.connectAndLogin = exports.updatePassword = exports.setStoredLoginObj = exports.removeStoredLoginObj = exports.getStoredLoginObj = exports.resetUserPassword = exports.mailPasswordToUser = exports.getEntityComParserEnv = exports.getClientParserEnv = exports.updateRuleDoc = exports.updateRuleExtended = exports.updateUserDoc = exports.updateUserExtended = exports.updateChannelExtended = exports.updateThingDoc = exports.updateThingExtended = exports.updateAssetDoc = exports.updateAssetExtended = exports.ensureEntityConf = exports.reqEntityConf = exports.presenceFor = exports.fromChannels = exports.fromChannel = exports.getUnitFromChannel = exports.getChannelAndTypeFromRid = exports.getChannelTypeFromChannel = exports.tapLogReqError = exports.logReqError = exports.unsubEntityUpdates = exports.subEntityUpdates = exports.confUpdatesChannel = exports.pwHash = exports.pubChannel = exports.pub = exports.unsubPresence = exports.subPresence = exports.unsubChannel = exports.subChannel = exports.unsub = exports.sub = exports.rpc = void 0;

var R = _interopRequireWildcard(require("ramda"));

var _subSeconds = _interopRequireDefault(require("date-fns/fp/subSeconds"));

var _get = _interopRequireDefault(require("lodash/fp/get"));

var _sha = _interopRequireDefault(require("crypto-js/sha256"));

var _noTry = require("no-try");

var _index = require("./index");

var _transforms = require("../transforms");

var _confParsing = require("../conf-parsing");

var _dmUtils = require("../dm-utils");

var _dataUtils = require("../data-utils");

var _api = require("./api");

var _unit = require("../unit");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _nonIterableRest(); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/**
 * ==================================================================
 * WORK IN PROGRESS
 * >>>>>>>>>>>>>>>>
 */
// const useFromConf = initArgs => {
// const [args, setArgs] = useState(initArgs);
// const [entities, setEntities] = useState([]);
//
// useEffect(() => {
//   // confCtrl.send(args);
// }, [args]);
//
// return { entities, setArgs };
// };
// const { entities, setArgs } = useConf({ target: 'asset', rids: [], filter: ['=', 'id', 'X'] });
// const { data, setArgs } = useBus({ channels: [], last: true, cb: () => {} });

/**
 * <<<<<<<<<<<<<<<<
 * WORK IN PROGRESS
 * ==================================================================
 */
var rpc = R.curry(function (id, args) {
  return _api.i4Context.client.rpc(id, args);
});
exports.rpc = rpc;
var sub = R.curry(function (callback, channel) {
  return _api.i4Context.client.sub(channel, callback);
});
exports.sub = sub;

var unsub = function unsub() {
  var _i4Context$client;

  return (_i4Context$client = _api.i4Context.client).unsub.apply(_i4Context$client, arguments);
};

exports.unsub = unsub;
var subChannel = R.curry(function (callback, rid) {
  return _api.i4Context.client.subChannel(rid, callback);
});
exports.subChannel = subChannel;

var unsubChannel = function unsubChannel() {
  var _i4Context$client2;

  return (_i4Context$client2 = _api.i4Context.client).unsubChannel.apply(_i4Context$client2, arguments);
};

exports.unsubChannel = unsubChannel;
var subPresence = R.curry(function (callback, id) {
  return _api.i4Context.client.subPresence(id, callback);
});
exports.subPresence = subPresence;

var unsubPresence = function unsubPresence() {
  var _i4Context$client3;

  return (_i4Context$client3 = _api.i4Context.client).unsubPresence.apply(_i4Context$client3, arguments);
};

exports.unsubPresence = unsubPresence;

var pub = function pub() {
  var _i4Context$client4;

  return (_i4Context$client4 = _api.i4Context.client).pub.apply(_i4Context$client4, arguments);
};

exports.pub = pub;

var pubChannel = function pubChannel() {
  var _i4Context$client5;

  return (_i4Context$client5 = _api.i4Context.client).pubChannel.apply(_i4Context$client5, arguments);
};
/**
 * Hash a password (or other string)
 * @param {string} pw A password
 * @returns {string} A hash string
 */


exports.pubChannel = pubChannel;

var pwHash = function pwHash(pw) {
  return String((0, _sha["default"])(pw));
};
/**
 * [curried] From type & rid, get the channel id for updates on that record
 * @param {string} type Type of entity
 * @param {string} rid Entity rid
 * @returns {string} A bus channel id for entity updates
 */


exports.pwHash = pwHash;
var confUpdatesChannel = R.curry(function (type, rid) {
  return "conf/".concat(type, "/update/").concat(rid);
});
exports.confUpdatesChannel = confUpdatesChannel;

var subEntityUpdates = function subEntityUpdates(type) {
  var ridToChannel = confUpdatesChannel(type);
  return function (cb) {
    return R.forEach(R.o(sub(cb), ridToChannel));
  };
};

exports.subEntityUpdates = subEntityUpdates;

var unsubEntityUpdates = function unsubEntityUpdates(type) {
  var ridToChannel = confUpdatesChannel(type);
  return function (rids, cb) {
    return R.forEach(R.o(function (ch) {
      return unsub(ch, cb);
    }, ridToChannel))(rids);
  };
};

exports.unsubEntityUpdates = unsubEntityUpdates;

var logReqError = function logReqError() {
  for (var _len = arguments.length, rpcs = new Array(_len), _key = 0; _key < _len; _key++) {
    rpcs[_key] = arguments[_key];
  }

  return function (err) {
    return console.warn("Request to \"".concat(rpcs.join('|'), "\" failed -"), err);
  };
};

exports.logReqError = logReqError;

var tapLogReqError = function tapLogReqError() {
  for (var _len2 = arguments.length, rpcs = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    rpcs[_key2] = arguments[_key2];
  }

  return function (err) {
    logReqError.apply(void 0, rpcs)(err);
    throw err;
  };
};
/**
 * Get a channel's ChannelType record from a channel record.
 * @func
 * @static
 * @param {type} rid A channel record
 * @returns {Promise} A Promise of a type record
 */


exports.tapLogReqError = tapLogReqError;

var getChannelTypeFromChannel = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2) {
    var id, _ref3, _ref4, type;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            id = _ref2.type;

            if (id) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return", undefined);

          case 3:
            _context.next = 5;
            return (0, _api.readChannelType)({
              rids: [],
              filter: ['=', 'id', id]
            });

          case 5:
            _ref3 = _context.sent;
            _ref4 = _slicedToArray(_ref3, 1);
            type = _ref4[0];
            return _context.abrupt("return", type);

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getChannelTypeFromChannel(_x) {
    return _ref.apply(this, arguments);
  };
}();
/**
 * Get a channel record and its channel type record (if any).
 * @func
 * @static
 * @param {type} rid A channel rid
 * @returns {Promise} A Promise of an object with the type record and the channel record.
 */


exports.getChannelTypeFromChannel = getChannelTypeFromChannel;

var getChannelAndTypeFromRid = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(rid, typeDocs) {
    var _ref6, _ref7, _ref7$, channel, type;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _api.readChannel)({
              rids: [rid]
            });

          case 2:
            _ref6 = _context2.sent;
            _ref7 = _slicedToArray(_ref6, 1);
            _ref7$ = _ref7[0];
            channel = _ref7$ === void 0 ? {} : _ref7$;

            if (!R.has(channel.type)(typeDocs)) {
              _context2.next = 8;
              break;
            }

            return _context2.abrupt("return", {
              channel: channel,
              type: typeDocs[channel.type]
            });

          case 8:
            _context2.next = 10;
            return getChannelTypeFromChannel(channel);

          case 10:
            _context2.t0 = _context2.sent;

            if (_context2.t0) {
              _context2.next = 13;
              break;
            }

            _context2.t0 = {};

          case 13:
            type = _context2.t0;
            return _context2.abrupt("return", {
              channel: channel,
              type: type
            });

          case 15:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function getChannelAndTypeFromRid(_x2, _x3) {
    return _ref5.apply(this, arguments);
  };
}();

exports.getChannelAndTypeFromRid = getChannelAndTypeFromRid;

var getUnitFromChannel = /*#__PURE__*/function () {
  var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(channelRid) {
    var channelAndType, type, unit;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return getChannelAndTypeFromRid(channelRid);

          case 2:
            channelAndType = _context3.sent;

            if (channelAndType) {
              _context3.next = 5;
              break;
            }

            return _context3.abrupt("return", undefined);

          case 5:
            type = channelAndType.type;

            if (type) {
              _context3.next = 8;
              break;
            }

            return _context3.abrupt("return", undefined);

          case 8:
            unit = type.unit;
            return _context3.abrupt("return", unit);

          case 10:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function getUnitFromChannel(_x4) {
    return _ref8.apply(this, arguments);
  };
}();
/**
 * Main function for subscribing to and getting historic data from a channel.
 * @func
 * @static
 * @param {object} options
 * @param {string} options.rid
 * @param {boolean} options.last If to include last value
 * @param {number} options.tail How many historic values to fetch
 * @param {number} options.ttl Time to live as seconds
 * @param {function} options.cb Callback (for one/each value)
 * @param {function} options.historyCb Callback for history batch
 * @param {Date} options.from Time to start history reading
 * @param {Date} options.to Time to stop history reading
 * @param {boolean} options.noSub If not to subscribe
 * @param {string} options.path Extract a path from each message
 * @param {boolean} options.noTsToDate No Date conversion
 * @param {string} options.busChannel Raw channel (instead of rid)
 * @param {object} options.typeDoc Already fetched ChannelType for channel
 * @returns {Promise} Unsubscribe function if relevant, otherwise historic data, or undefined
 */


exports.getUnitFromChannel = getUnitFromChannel;

var fromChannel = /*#__PURE__*/function () {
  var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref10) {
    var rid, last, tail, ttl, cb, historyCb, from, to, noSub, path, unit, noTsToDate, busChannel, _ref10$reverse, reverse, typeDoc, converter, toUnit, fromUnit, _getConverter, _getConverter2, fixMsg, dhPromise, callback;

    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            rid = _ref10.rid, last = _ref10.last, tail = _ref10.tail, ttl = _ref10.ttl, cb = _ref10.cb, historyCb = _ref10.historyCb, from = _ref10.from, to = _ref10.to, noSub = _ref10.noSub, path = _ref10.path, unit = _ref10.unit, noTsToDate = _ref10.noTsToDate, busChannel = _ref10.busChannel, _ref10$reverse = _ref10.reverse, reverse = _ref10$reverse === void 0 ? false : _ref10$reverse, typeDoc = _ref10.typeDoc;

            if (!(rid === undefined && busChannel === undefined)) {
              _context4.next = 3;
              break;
            }

            return _context4.abrupt("return", undefined);

          case 3:
            converter = R.identity;

            if (!_api.i4Context.unitSettings) {
              _context4.next = 18;
              break;
            }

            _context4.t0 = unit;

            if (_context4.t0) {
              _context4.next = 15;
              break;
            }

            if (!typeDoc) {
              _context4.next = 11;
              break;
            }

            _context4.t1 = typeDoc.unit;
            _context4.next = 14;
            break;

          case 11:
            _context4.next = 13;
            return getUnitFromChannel(rid);

          case 13:
            _context4.t1 = _context4.sent;

          case 14:
            _context4.t0 = _context4.t1;

          case 15:
            fromUnit = _context4.t0;
            toUnit = fromUnit;

            if (fromUnit) {
              _getConverter = (0, _unit.getConverter)(fromUnit, _api.i4Context.unitSettings);
              _getConverter2 = _slicedToArray(_getConverter, 2);
              toUnit = _getConverter2[0];
              converter = _getConverter2[1];
              console.log('Created converter:', fromUnit, '->', toUnit);

              if (toUnit && converter) {
                converter = (0, _unit.convertMaybeTiip)(converter);
              }
            }

          case 18:
            fixMsg = R.compose(R.when(function () {
              return path !== undefined;
            }, (0, _get["default"])(path)), R.when(function () {
              return !noTsToDate;
            }, _dmUtils.evolveTsToDate), _dmUtils.ensureTsV3);

            if (!(rid && (last || tail || from || to || ttl))) {
              _context4.next = 23;
              break;
            }

            dhPromise = (0, _api.dataHistoryRead)(_objectSpread({
              channel: rid
            }, from ? {
              from: (0, _dmUtils.dateToUtcTs)(from)
            } : {}, {}, to ? {
              to: (0, _dmUtils.dateToUtcTs)(to)
            } : {}, {}, ttl ? {
              from: (0, _dmUtils.dateToTs)((0, _subSeconds["default"])(ttl)(new Date()))
            } : {}, {}, tail || last ? {
              limit: tail || Number(last)
            } : {}, {
              projection: ['pl', 'ts', 'sig'] // TODO: This is problematic together with fix and converter ?? Or not?

            })).then(function (results) {
              var data = R.compose(R.when(function () {
                return !path || path.startsWith('pl');
              }, converter), R.map(fixMsg), R.when(function () {
                return !reverse;
              }, R.reverse))(results);
              if (historyCb) historyCb(data);else if (cb) data.map(cb);
              return data;
            }); // if this is a history fetch (no subscribing) -> return history data promise

            if (!noSub) {
              _context4.next = 23;
              break;
            }

            return _context4.abrupt("return", dhPromise);

          case 23:
            if (noSub) {
              _context4.next = 30;
              break;
            }

            callback = R.compose(cb, R.when(function () {
              return !path || path.startsWith('pl');
            }, converter), fixMsg);

            if (!busChannel) {
              _context4.next = 28;
              break;
            }

            _api.i4Context.client.sub(busChannel, callback);

            return _context4.abrupt("return", function () {
              return _api.i4Context.client.unsub(busChannel, callback);
            });

          case 28:
            _api.i4Context.client.subChannel(rid, callback);

            return _context4.abrupt("return", function () {
              return _api.i4Context.client.unsubChannel(rid, callback);
            });

          case 30:
            return _context4.abrupt("return", undefined);

          case 31:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function fromChannel(_x5) {
    return _ref9.apply(this, arguments);
  };
}();
/**
 * Main function for subscribing to and getting historic data from multiple channels.
 * @func
 * @static
 * @param {object} options
 * @param {array<object>} settings.channels Channel specs, each with rid, [path], [type].
 * @param {bool} settings.last If the last value should be fetched from history.
 * @param {number} settings.ttl Time to live [s]. How far back in time to fetch history.
 * @param {Date} settings.from A certain time to fetch history from.
 * @param {Date} settings.to Only fetch history up until this time.
 * @param {array} settings.lengths Each channel's space in resulting pl. Automatically calculated from history and paths if not given.
 * @param {boolean} settings.noHistoryCb Make fetched history be iterated into "propName" instead of "historyPropName" being used
 * @param {boolean} options.last If to include last value
 * @param {boolean} options.noSub If not to subscribe
 * @param {boolean} options.noTsToDate No Date conversion
 * @param {object} options.typeDocs Already fetched channel types
 * @returns {Promise} Unsubscribe functions if relevant, otherwise historic data, or undefined
 */


exports.fromChannel = fromChannel;

var fromChannels = /*#__PURE__*/function () {
  var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref12) {
    var channels, cb, historyCb, ttl, from, to, last, noSub, noTsToDate, typeDocs, _ref12$lengths, lengths, counts, histories, merged;

    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            channels = _ref12.channels, cb = _ref12.cb, historyCb = _ref12.historyCb, ttl = _ref12.ttl, from = _ref12.from, to = _ref12.to, last = _ref12.last, noSub = _ref12.noSub, noTsToDate = _ref12.noTsToDate, typeDocs = _ref12.typeDocs, _ref12$lengths = _ref12.lengths, lengths = _ref12$lengths === void 0 ? [] : _ref12$lengths;
            counts = lengths;

            if (!(ttl || from || to || last)) {
              _context5.next = 11;
              break;
            }

            _context5.next = 5;
            return Promise.all(channels.map(function (_ref13) {
              var rid = _ref13.rid,
                  type = _ref13.type,
                  path = _ref13.path;
              return fromChannel({
                rid: rid,
                ttl: ttl,
                from: from,
                to: to,
                last: last,
                noSub: true,
                noTsToDate: noTsToDate,
                typeDoc: type && typeDocs ? typeDocs[type] : undefined
              }).then(function (data) {
                return {
                  path: path,
                  data: data
                };
              });
            }));

          case 5:
            histories = _context5.sent;
            // -> [[{ts, pl}, {ts, pl}], [{ts, pl}]]
            // console.log('histories:', histories);

            /* eslint-disable no-param-reassign */
            counts = counts.length ? counts : histories.map(function (_ref14) {
              var path = _ref14.path,
                  _ref14$data = _ref14.data;
              _ref14$data = _ref14$data === void 0 ? [] : _ref14$data;

              var _ref14$data2 = _slicedToArray(_ref14$data, 1),
                  _ref14$data2$ = _ref14$data2[0],
                  point = _ref14$data2$ === void 0 ? {} : _ref14$data2$;

              var value = (0, _dmUtils.dataInPoint)(path, point);
              return Array.isArray(value) ? value.length : 1;
            }); // -> [1, 2, 1, 1]
            // console.log('counts:', counts);

            merged = R.compose(R.when(function () {
              return last;
            }, R.o(R.of, _dmUtils.msgMerge)), // R.tap(dss => console.log('after datasetMerge:', JSON.stringify(dss))),
            (0, _dmUtils.datasetMerge)(counts) // R.tap(dss => console.log('before datasetMerge:', JSON.stringify(dss))),
            )(histories); // console.log('merged:', merged);

            if (historyCb) historyCb(merged);else if (cb) merged.map(cb);

            if (!noSub) {
              _context5.next = 11;
              break;
            }

            return _context5.abrupt("return", merged);

          case 11:
            return _context5.abrupt("return", noSub ? undefined : Promise.all(channels.map(function (_ref15, idx) {
              var rid = _ref15.rid,
                  type = _ref15.type,
                  path = _ref15.path;

              // console.log('Sub-ing 1:', rid, type, path, counts, idx);
              var _R$splitAt = R.splitAt(idx)(counts),
                  _R$splitAt2 = _slicedToArray(_R$splitAt, 2),
                  before = _R$splitAt2[0],
                  _R$splitAt2$ = _toArray(_R$splitAt2[1]),
                  _ = _R$splitAt2$[0],
                  after = _R$splitAt2$.slice(1); // eslint-disable-line no-unused-vars
              // console.log('Sub-ing 2:', before, after);


              var callback = R.compose(cb, // R.tap(x => (before || after) && console.log('Conformed:', path, x)),
              (0, _dmUtils.conformPoint)(before, after, path) // R.tap(x => (before || after) && console.log('Raw in:', path, x)),
              );
              return fromChannel({
                rid: rid,
                cb: callback,
                // path,
                noTsToDate: noTsToDate,
                typeDoc: type && typeDocs ? typeDocs[type] : undefined
              });
            })));

          case 12:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function fromChannels(_x6) {
    return _ref11.apply(this, arguments);
  };
}();

exports.fromChannels = fromChannels;

var presenceFor = function presenceFor(_ref16) {
  var id = _ref16.id,
      cb = _ref16.cb,
      noSub = _ref16.noSub;
  if (id === undefined) return undefined;
  (0, _api.presenceListClients)({}).then(function (reply) {
    return cb(reply.includes(id));
  });

  if (!noSub) {
    var callback = R.o(cb, R.prop('login'));
    var channel = "presence/".concat(id);
    sub(callback, channel);

    var unsubscribe = function unsubscribe() {
      return unsub(channel, callback);
    };

    return unsubscribe; // notify caller about a subscription made
  }

  return undefined;
};

exports.presenceFor = presenceFor;
var reqEntityConf = R.curry(function (id, entityRid) {
  return (0, _api.readConfiguration)(_objectSpread({
    entities: (0, _transforms.ensureArray)(entityRid),
    rids: []
  }, id ? {
    filter: ['=', 'id', id]
  } : {})).then(function (results) {
    return id && typeof entityRid === 'string' ? results[0] : results;
  });
});
exports.reqEntityConf = reqEntityConf;

var ensureEntityConf = /*#__PURE__*/function () {
  var _ref17 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(id, entityRid, conf) {
    var result, newConf;
    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return reqEntityConf(id, entityRid);

          case 2:
            result = _context6.sent;

            if (!result) {
              _context6.next = 7;
              break;
            }

            _context6.next = 6;
            return (0, _api.updateConfiguration)({
              rids: [result.rid],
              properties: conf
            });

          case 6:
            return _context6.abrupt("return", result);

          case 7:
            _context6.next = 9;
            return (0, _api.createConfiguration)({
              id: id,
              properties: conf
            });

          case 9:
            newConf = _context6.sent;
            _context6.next = 12;
            return (0, _api.addConfigurationToEntity)({
              rids: [entityRid],
              configurations: [newConf.rid]
            });

          case 12:
            return _context6.abrupt("return", newConf);

          case 13:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));

  return function ensureEntityConf(_x7, _x8, _x9) {
    return _ref17.apply(this, arguments);
  };
}();

exports.ensureEntityConf = ensureEntityConf;

var updateAssetExtended = function updateAssetExtended(_ref18) {
  var rids = _ref18.rids,
      type = _ref18.type,
      removedChannels = _ref18.removedChannels,
      addedChannels = _ref18.addedChannels,
      removedChildren = _ref18.removedChildren,
      addedChildren = _ref18.addedChildren,
      properties = _ref18.properties;
  var promises = [];
  if (type !== undefined) promises.push((0, _api.setAssetType)({
    rids: rids,
    type: type
  })["catch"](tapLogReqError(_api.setAssetType)));
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateAsset)({
    rids: rids,
    properties: properties
  })["catch"](tapLogReqError(_api.updateAsset)));
  if (!(0, _transforms.nilOrEmpty)(removedChannels) || !(0, _transforms.nilOrEmpty)(addedChannels)) promises.push((0, _api.removeChannelFromAsset)({
    rids: rids,
    channelIds: removedChannels
  }).then(function () {
    return (0, _api.addChannelToAsset)({
      rids: rids,
      channels: addedChannels
    });
  })["catch"](tapLogReqError(_api.removeChannelFromAsset)));
  if (!(0, _transforms.nilOrEmpty)(removedChildren)) promises.push((0, _api.removeChildFromAsset)({
    rids: rids,
    children: removedChildren
  }).then(function () {
    return !(0, _transforms.nilOrEmpty)(addedChildren) ? (0, _api.addChildToAsset)({
      rids: rids,
      children: addedChildren
    }) : null;
  })["catch"](tapLogReqError(_api.removeChildFromAsset)));else if (!(0, _transforms.nilOrEmpty)(addedChildren)) promises.push((0, _api.addChildToAsset)({
    rids: rids,
    children: addedChildren
  })["catch"](tapLogReqError(_api.addChildToAsset)));
  return Promise.all(promises);
};

exports.updateAssetExtended = updateAssetExtended;

var updateAssetDoc = function updateAssetDoc(oldDoc, doc) {
  var rid = oldDoc.rid,
      oldId = oldDoc.id,
      _oldDoc$channels = oldDoc.channels,
      oldChannels = _oldDoc$channels === void 0 ? {} : _oldDoc$channels,
      _oldDoc$children = oldDoc.children,
      oldChildren = _oldDoc$children === void 0 ? [] : _oldDoc$children,
      oldType = oldDoc.type;

  var id = doc.id,
      channels = doc.channels,
      children = doc.children,
      type = doc.type,
      rest = _objectWithoutProperties(doc, ["id", "channels", "children", "type"]);

  var unchangedChannels = R.equals(oldChannels)(channels);
  var removedChildren = R.without(children)(oldChildren);
  var addedChildren = R.without(oldChildren)(children);
  return updateAssetExtended(_objectSpread({
    rids: [rid]
  }, type !== oldType ? {
    type: type
  } : {}, {}, unchangedChannels ? {} : {
    removedChannels: Object.keys(oldChannels),
    addedChannels: channels
  }, {}, R.isEmpty(removedChildren) ? {} : {
    removedChildren: removedChildren
  }, {}, R.isEmpty(addedChildren) ? {} : {
    addedChildren: addedChildren
  }, {
    properties: id !== oldId ? _objectSpread({}, rest, {
      id: id
    }) : rest
  }));
};

exports.updateAssetDoc = updateAssetDoc;

var updateThingExtended = function updateThingExtended(_ref19) {
  var rids = _ref19.rids,
      credentials = _ref19.credentials,
      type = _ref19.type,
      properties = _ref19.properties,
      removedRoles = _ref19.removedRoles,
      addedRoles = _ref19.addedRoles;
  var promises = [];
  if (type !== undefined) promises.push((0, _api.setThingType)({
    rids: rids,
    type: type
  })["catch"](tapLogReqError(_api.setThingType)));
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateThing)({
    rids: rids,
    properties: properties
  })["catch"](tapLogReqError(_api.updateThing)));
  if (!(0, _transforms.nilOrEmpty)(credentials)) promises.push( // TODO: make a loop here, for correctness?
  (0, _api.updateThingCredentials)(_objectSpread({
    rid: rids[0]
  }, credentials))["catch"](tapLogReqError(_api.updateThing)));
  if (!(0, _transforms.nilOrEmpty)(removedRoles)) promises.push((0, _api.removeRoleFromThing)({
    rids: rids,
    roles: removedRoles
  }).then(function () {
    return !(0, _transforms.nilOrEmpty)(addedRoles) ? (0, _api.addRoleToThing)({
      rids: rids,
      roles: addedRoles
    }) : null;
  })["catch"](tapLogReqError(_api.removeRoleFromThing)));else if (!(0, _transforms.nilOrEmpty)(addedRoles)) promises.push((0, _api.addRoleToThing)({
    rids: rids,
    roles: addedRoles
  })["catch"](tapLogReqError(_api.addRoleToThing)));
  return Promise.all(promises);
};

exports.updateThingExtended = updateThingExtended;

var updateThingDoc = function updateThingDoc(oldDoc, doc) {
  var rid = oldDoc.rid,
      oldId = oldDoc.id,
      _oldDoc$roles = oldDoc.roles,
      oldRoles = _oldDoc$roles === void 0 ? [] : _oldDoc$roles,
      oldType = oldDoc.type;

  var id = doc.id,
      roles = doc.roles,
      type = doc.type,
      password = doc.password,
      rest = _objectWithoutProperties(doc, ["id", "roles", "type", "password"]); // console.log('updateThingChanges:', oldDoc, doc);


  var removedRoles = R.without(roles)(oldRoles);
  var addedRoles = R.without(oldRoles)(roles);
  var hasNewCredentials = id !== oldId || password;
  return updateThingExtended(_objectSpread({
    rids: [rid]
  }, hasNewCredentials ? {
    credentials: _objectSpread({}, id !== oldId ? {
      id: id
    } : {}, {}, password ? {
      password: pwHash(password)
    } : {})
  } : {}, {}, type !== oldType ? {
    type: type
  } : {}, {}, R.isEmpty(removedRoles) ? {} : {
    removedRoles: removedRoles
  }, {}, R.isEmpty(addedRoles) ? {} : {
    addedRoles: addedRoles
  }, {
    properties: rest
  }));
};

exports.updateThingDoc = updateThingDoc;

var updateChannelExtended = function updateChannelExtended(rids, type, properties) {
  var promises = [];
  if (type !== undefined) promises.push((0, _api.setChannelType)({
    rids: rids,
    type: type
  })["catch"](tapLogReqError(_api.setChannelType)));
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateChannel)({
    rids: rids,
    properties: properties
  })["catch"](tapLogReqError(_api.updateChannel)));
  return Promise.all(promises);
};

exports.updateChannelExtended = updateChannelExtended;

var updateUserExtended = function updateUserExtended(_ref20) {
  var rids = _ref20.rids,
      properties = _ref20.properties,
      removedRoles = _ref20.removedRoles,
      addedRoles = _ref20.addedRoles,
      id = _ref20.id,
      password = _ref20.password;
  var promises = [];
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateUser)({
    rids: rids,
    properties: properties
  })["catch"](tapLogReqError(_api.updateUser)));
  if (!(0, _transforms.nilOrEmpty)(removedRoles)) promises.push((0, _api.removeRoleFromUser)({
    rids: rids,
    roles: removedRoles
  }).then(function () {
    return !(0, _transforms.nilOrEmpty)(addedRoles) ? (0, _api.addRoleToUser)({
      rids: rids,
      roles: addedRoles
    }) : null;
  })["catch"](tapLogReqError(_api.removeRoleFromUser, _api.addRoleToUser)));else if (!(0, _transforms.nilOrEmpty)(addedRoles)) promises.push((0, _api.addRoleToUser)({
    rids: rids,
    roles: addedRoles
  })["catch"](tapLogReqError(_api.addRoleToUser)));
  if (id || password) rids.forEach(function (rid) {
    return promises.push((0, _api.updateUserCredentials)(_objectSpread({
      rid: rid
    }, id ? {
      id: id
    } : {}, {}, password ? {
      password: password
    } : {}))["catch"](tapLogReqError(_api.updateUserCredentials)));
  });
  return Promise.all(promises);
};

exports.updateUserExtended = updateUserExtended;

var updateUserDoc = function updateUserDoc(oldDoc, doc) {
  var rid = oldDoc.rid,
      oldId = oldDoc.id,
      oldName = oldDoc.name,
      _oldDoc$roles2 = oldDoc.roles,
      oldRoles = _oldDoc$roles2 === void 0 ? [] : _oldDoc$roles2;

  var name = doc.name,
      id = doc.id,
      password = doc.password,
      roles = doc.roles,
      rest = _objectWithoutProperties(doc, ["name", "id", "password", "roles"]);

  var removedRoles = R.without(roles)(oldRoles);
  var addedRoles = R.without(oldRoles)(roles);
  return updateUserExtended(_objectSpread({
    rids: [rid]
  }, R.isEmpty(removedRoles) ? {} : {
    removedRoles: removedRoles
  }, {}, R.isEmpty(addedRoles) ? {} : {
    addedRoles: addedRoles
  }, {
    properties: name !== oldName ? _objectSpread({}, rest, {
      name: name
    }) : rest
  }, id !== oldId ? {
    id: id
  } : {}, {}, password ? {
    password: pwHash(password)
  } : {}));
};

exports.updateUserDoc = updateUserDoc;

var updateRuleExtended = function updateRuleExtended(_ref21) {
  var rids = _ref21.rids,
      properties = _ref21.properties,
      removedAssets = _ref21.removedAssets,
      addedAssets = _ref21.addedAssets;
  var promises = [];
  if (!(0, _transforms.nilOrEmpty)(properties)) promises.push((0, _api.updateRule)({
    rids: rids,
    properties: properties
  })["catch"](tapLogReqError(_api.updateRule)));
  if (!(0, _transforms.nilOrEmpty)(removedAssets)) promises.push((0, _api.removeRuleFromAsset)({
    rids: removedAssets,
    rules: rids
  }).then(function () {
    return !(0, _transforms.nilOrEmpty)(addedAssets) ? (0, _api.addRuleToAsset)({
      rids: addedAssets,
      rules: rids
    }) : null;
  })["catch"](tapLogReqError(_api.removeRuleFromAsset, _api.addRuleToAsset)));else if (!(0, _transforms.nilOrEmpty)(addedAssets)) promises.push((0, _api.addRuleToAsset)({
    rids: addedAssets,
    rules: rids
  })["catch"](tapLogReqError(_api.addRuleToAsset)));
  return Promise.all(promises);
};

exports.updateRuleExtended = updateRuleExtended;

var updateRuleDoc = function updateRuleDoc(oldDoc, doc) {
  var rid = oldDoc.rid,
      _oldDoc$assets = oldDoc.assets,
      oldAssets = _oldDoc$assets === void 0 ? [] : _oldDoc$assets;

  var assets = doc.assets,
      rest = _objectWithoutProperties(doc, ["assets"]);

  var removedAssets = R.without(assets)(oldAssets);
  var addedAssets = R.without(oldAssets)(assets);
  return updateRuleExtended(_objectSpread({
    rids: [rid]
  }, R.isEmpty(removedAssets) ? {} : {
    removedAssets: removedAssets
  }, {}, R.isEmpty(addedAssets) ? {} : {
    addedAssets: addedAssets
  }, {
    properties: rest
  }));
};
/**
 * This parser env is mainly used sync, requests with results may not make sense
 */


exports.updateRuleDoc = updateRuleDoc;

var getClientParserEnv = function getClientParserEnv() {
  return _objectSpread({}, (0, _confParsing.getComParserEnv)(_api.i4Context.client));
};

exports.getClientParserEnv = getClientParserEnv;

var getEntityComParserEnv = function getEntityComParserEnv(entityRid) {
  return _objectSpread({}, (0, _confParsing.getComParserEnv)(_api.i4Context.client), {
    reqEntityConf: reqEntityConf(R.__, entityRid)
  });
};

exports.getEntityComParserEnv = getEntityComParserEnv;

var newUserMd = function newUserMd(id, password, supportEmail, linkUrl) {
  return "A new account has been created for you at ".concat(linkUrl, "\n\nYour account credentials are:\n\n__id: ").concat(id, "__\n\n__password: ").concat(password, "__\n\nYou can change your password in your profile after logging in by clicking your user icon in the top left corner of the screen.\n\nThis mail can not be replied to. For questions, email:\n[").concat(supportEmail, "](mailto:").concat(supportEmail, ")\n  ");
};

var resetPasswordMd = function resetPasswordMd(id, password, supportEmail, linkUrl) {
  return "Your password at ".concat(linkUrl, " has been reset.\n\nYour new credentials are:\n\n__id:&nbsp;").concat(id, "__\n\n__password:&nbsp;").concat(password, "__\n\nYou can change your password in your profile after logging in by clicking your user icon in the top left corner of the screen.\n\nThis mail can not be replied to. For questions, email:\n[").concat(supportEmail, "](mailto:").concat(supportEmail, ")\n  ");
};

var mailPasswordToUser = /*#__PURE__*/function () {
  var _ref22 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(email, id, password) {
    var supportConf,
        template,
        supportEmail,
        _supportConf$userCrea,
        linkUrl,
        _args7 = arguments;

    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            supportConf = _args7.length > 3 && _args7[3] !== undefined ? _args7[3] : {};
            template = _args7.length > 4 ? _args7[4] : undefined;
            supportEmail = supportConf.email, _supportConf$userCrea = supportConf.userCreationLink, linkUrl = _supportConf$userCrea === void 0 ? "".concat(document.location.protocol, "//").concat(document.location.host.split('/')[0]) : _supportConf$userCrea;

            if (!(!email || !(0, _dataUtils.validateEmail)(email))) {
              _context7.next = 5;
              break;
            }

            throw new Error("".concat(email, " is not a valid email."));

          case 5:
            return _context7.abrupt("return", (0, _api.mailerSend)({
              to: [email],
              subject: 'Account created',
              markdown: (template || newUserMd)(id, password, supportEmail, linkUrl)
            }));

          case 6:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  }));

  return function mailPasswordToUser(_x10, _x11, _x12) {
    return _ref22.apply(this, arguments);
  };
}();

exports.mailPasswordToUser = mailPasswordToUser;

var resetUserPassword = /*#__PURE__*/function () {
  var _ref23 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(rid, email) {
    var supportConf,
        template,
        supportEmail,
        _supportConf$userCrea2,
        linkUrl,
        newPassword,
        hashedNewPassword,
        _args8 = arguments;

    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            supportConf = _args8.length > 2 && _args8[2] !== undefined ? _args8[2] : {};
            template = _args8.length > 3 ? _args8[3] : undefined;
            supportEmail = supportConf.email, _supportConf$userCrea2 = supportConf.userCreationLink, linkUrl = _supportConf$userCrea2 === void 0 ? "".concat(document.location.protocol, "//").concat(document.location.host.split('/')[0]) : _supportConf$userCrea2;
            newPassword = (0, _dataUtils.generateString)();
            hashedNewPassword = pwHash(newPassword);
            return _context8.abrupt("return", (0, _api.updateUserCredentials)({
              rid: rid,
              password: hashedNewPassword
            }).then(function () {
              if (!email || !(0, _dataUtils.validateEmail)(email)) throw new Error("".concat(email, " is not a valid email."));
              return (0, _api.mailerSend)({
                to: [email],
                subject: 'Password reset',
                markdown: (template || resetPasswordMd)(email, newPassword, supportEmail, linkUrl)
              });
            }));

          case 6:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8);
  }));

  return function resetUserPassword(_x13, _x14) {
    return _ref23.apply(this, arguments);
  };
}();

exports.resetUserPassword = resetUserPassword;
var loginObjKey = '_loginObj_';

var getStoredLoginObj = function getStoredLoginObj() {
  return JSON.parse(localStorage.getItem(loginObjKey));
};

exports.getStoredLoginObj = getStoredLoginObj;

var removeStoredLoginObj = function removeStoredLoginObj() {
  return localStorage.removeItem(loginObjKey);
};

exports.removeStoredLoginObj = removeStoredLoginObj;

var setStoredLoginObj = function setStoredLoginObj(obj) {
  try {
    localStorage.setItem(loginObjKey, JSON.stringify(obj));
    return true;
  } catch (err) {
    console.warn('Failed to store login object:', err);
    return false;
  }
};

exports.setStoredLoginObj = setStoredLoginObj;

var updatePassword = /*#__PURE__*/function () {
  var _ref24 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(oldUnhashed, newUnhashed) {
    var newHashed, loginObj;
    return regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            newHashed = pwHash(newUnhashed);
            _context9.next = 3;
            return (0, _api.updateOwnPassword)({
              oldPassword: pwHash(oldUnhashed),
              newPassword: newHashed
            });

          case 3:
            loginObj = getStoredLoginObj();

            if (loginObj) {
              setStoredLoginObj(_objectSpread({}, loginObj, {
                password: newHashed
              }));
            }

          case 5:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee9);
  }));

  return function updatePassword(_x15, _x16) {
    return _ref24.apply(this, arguments);
  };
}();

exports.updatePassword = updatePassword;
var defaultUnitSettings = {
  pressure: 'bar',
  temperature: 'tempC' // length: 'm',
  // current: 'A',

};
var processUnitSettings = R.compose(R.tap(function (obj) {
  return _api.i4Context.unitSettings = obj;
}), // TODO: cache in IndexedDB indstead
R.omit(['id', 'rid']));

var connectAndLogin = /*#__PURE__*/function () {
  var _ref25 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
    var _ref26,
        id,
        password,
        serverAddress,
        _ref26$options,
        options,
        hashedPw,
        cachedLoginObj,
        loginObj,
        idFinal,
        pw,
        address,
        client,
        profile,
        rid,
        unitSettings,
        _args10 = arguments;

    return regeneratorRuntime.wrap(function _callee10$(_context10) {
      while (1) {
        switch (_context10.prev = _context10.next) {
          case 0:
            _ref26 = _args10.length > 0 && _args10[0] !== undefined ? _args10[0] : {}, id = _ref26.id, password = _ref26.password, serverAddress = _ref26.serverAddress, _ref26$options = _ref26.options, options = _ref26$options === void 0 ? {} : _ref26$options;
            hashedPw = pwHash(password);
            cachedLoginObj = getStoredLoginObj() || {};
            loginObj = _objectSpread({}, cachedLoginObj, {}, id ? {
              id: id,
              password: hashedPw
            } : {}, {}, serverAddress ? {
              serverAddress: serverAddress
            } : {});
            idFinal = loginObj.id, pw = loginObj.password, address = loginObj.serverAddress;

            if (!(!idFinal || !pw)) {
              _context10.next = 7;
              break;
            }

            throw new Error('Incomplete credentials');

          case 7:
            if (_api.i4Context.client) (0, _noTry.noTry)(_api.i4Context.client.close);
            client = (0, _index.createClient)();
            _context10.next = 11;
            return client.login(address, {
              id: idFinal,
              password: pw
            }, options);

          case 11:
            (0, _api.setContext)({
              client: client
            });
            setStoredLoginObj(loginObj);
            _context10.next = 15;
            return (0, _api.readProfile)();

          case 15:
            profile = _context10.sent;
            rid = profile.rid;
            _context10.t0 = processUnitSettings;
            _context10.next = 20;
            return reqEntityConf('unitSettings', rid);

          case 20:
            _context10.t1 = _context10.sent;

            if (_context10.t1) {
              _context10.next = 23;
              break;
            }

            _context10.t1 = defaultUnitSettings;

          case 23:
            _context10.t2 = _context10.t1;
            unitSettings = (0, _context10.t0)(_context10.t2);
            return _context10.abrupt("return", {
              loginObj: loginObj,
              profile: profile,
              unitSettings: unitSettings
            });

          case 26:
          case "end":
            return _context10.stop();
        }
      }
    }, _callee10);
  }));

  return function connectAndLogin() {
    return _ref25.apply(this, arguments);
  };
}();

exports.connectAndLogin = connectAndLogin;

var logoutAndForget = function logoutAndForget() {
  removeStoredLoginObj();
  if (_api.i4Context.client && _api.i4Context.client.close) _api.i4Context.client.close();
};

exports.logoutAndForget = logoutAndForget;