"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createClient = exports.ridToPresenceChannel = exports.ridToBusChannel = void 0;

var _client = require("@deepstream/client");

var _extendedDsClient = _interopRequireDefault(require("extended-ds-client"));

var R = _interopRequireWildcard(require("ramda"));

var _jstiip = _interopRequireDefault(require("jstiip"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/**
 * From a rid, get the channel id on the bus
 * @param {string} rid Channel entity rid
 * @returns {string} A bus channel id for channel data
 */
var ridToBusChannel = function ridToBusChannel(rid) {
  return "data/".concat(rid);
};

exports.ridToBusChannel = ridToBusChannel;

var ridToPresenceChannel = function ridToPresenceChannel(id) {
  return "presence/".concat(id);
};

exports.ridToPresenceChannel = ridToPresenceChannel;

var _login = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(serverAddress) {
    var credentials,
        _ref,
        onUnexpectedError,
        onConnectionError,
        onConnectionStateChanged,
        options,
        client,
        _args = arguments;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            credentials = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
            _ref = _args.length > 2 ? _args[2] : undefined;
            onUnexpectedError = _ref.onUnexpectedError, onConnectionError = _ref.onConnectionError, onConnectionStateChanged = _ref.onConnectionStateChanged, options = _objectWithoutProperties(_ref, ["onUnexpectedError", "onConnectionError", "onConnectionStateChanged"]);
            // const client = new DeepstreamClient(serverAddress, options); // TODO: USE for dsv5
            client = (0, _extendedDsClient["default"])(serverAddress);
            if (onUnexpectedError) client.on('error', onUnexpectedError); // ARGS: (error, event, topic)

            client.on('connectionStateChanged', function (state) {
              if (onConnectionStateChanged) onConnectionStateChanged(state);
              if (onConnectionError && state === 'ERROR') onConnectionError(); // All reconnects failed
            }); // await client.login(credentials); // TODO: USE for dsv5

            _context.next = 8;
            return client.p.login(credentials);

          case 8:
            return _context.abrupt("return", client);

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function login(_x) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * Publishes a message through the backend.
 * @func
 * @static
 * @param {string} channel The channel to publish on.
 * @param {Array} pl The payload to send.
 * @param {string} sig The signal data to apply to the published message.
 */


var _pub = function pub(client, channel, pl, sig) {
  // if (!channel || typeof channel !== 'string') return undefined;
  var plOk = pl === undefined || Array.isArray(pl);
  var msg = new _jstiip["default"]({
    pl: plOk ? pl : [pl],
    sig: sig
  });
  return client.event.emit(channel, msg.toJS());
};

var createClient = function createClient() {
  var rawClient;
  return {
    login: function () {
      var _login2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var _args2 = arguments;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _login.apply(void 0, _args2);

              case 2:
                return _context2.abrupt("return", rawClient = _context2.sent);

              case 3:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function login() {
        return _login2.apply(this, arguments);
      }

      return login;
    }(),
    close: function close() {
      return rawClient.off() || rawClient.close();
    },
    provide: function provide() {
      var _rawClient$rpc;

      return (_rawClient$rpc = rawClient.rpc).provide.apply(_rawClient$rpc, arguments);
    },
    unprovide: function unprovide() {
      var _rawClient$rpc2;

      return (_rawClient$rpc2 = rawClient.rpc).unprovide.apply(_rawClient$rpc2, arguments);
    },
    // rpc: R.curry((id, args) => rawClient.rpc.make(id, args)), // TODO: USE for dsv5
    rpc: R.curry(function (id, args) {
      return rawClient.rpc.p.make(id, args);
    }),
    pub: function pub() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _pub.apply(void 0, [rawClient].concat(args));
    },
    pubChannel: function pubChannel(channelRid) {
      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      return _pub.apply(void 0, [rawClient, ridToBusChannel(channelRid)].concat(args));
    },
    sub: function sub() {
      var _rawClient$event;

      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      (_rawClient$event = rawClient.event).subscribe.apply(_rawClient$event, args);

      return function () {
        var _rawClient$event2;

        return (_rawClient$event2 = rawClient.event).unsubscribe.apply(_rawClient$event2, args);
      };
    },
    subChannel: function subChannel(channelRid) {
      var _rawClient$event3;

      for (var _len4 = arguments.length, args = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
        args[_key4 - 1] = arguments[_key4];
      }

      (_rawClient$event3 = rawClient.event).subscribe.apply(_rawClient$event3, [ridToBusChannel(channelRid)].concat(args));

      return function () {
        var _rawClient$event4;

        return (_rawClient$event4 = rawClient.event).unsubscribe.apply(_rawClient$event4, [ridToBusChannel(channelRid)].concat(args));
      };
    },
    subPresence: function subPresence(clientId) {
      var _rawClient$event5;

      for (var _len5 = arguments.length, args = new Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
        args[_key5 - 1] = arguments[_key5];
      }

      (_rawClient$event5 = rawClient.event).subscribe.apply(_rawClient$event5, [ridToPresenceChannel(clientId)].concat(args));

      return function () {
        var _rawClient$event6;

        return (_rawClient$event6 = rawClient.event).unsubscribe.apply(_rawClient$event6, [ridToPresenceChannel(clientId)].concat(args));
      };
    },
    unsub: function unsub() {
      var _rawClient$event7;

      return (_rawClient$event7 = rawClient.event).unsubscribe.apply(_rawClient$event7, arguments);
    },
    unsubChannel: function unsubChannel(channelRid) {
      var _rawClient$event8;

      for (var _len6 = arguments.length, args = new Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
        args[_key6 - 1] = arguments[_key6];
      }

      return (_rawClient$event8 = rawClient.event).unsubscribe.apply(_rawClient$event8, [ridToBusChannel(channelRid)].concat(args));
    },
    unsubPresence: function unsubPresence(clientId) {
      var _rawClient$event9;

      for (var _len7 = arguments.length, args = new Array(_len7 > 1 ? _len7 - 1 : 0), _key7 = 1; _key7 < _len7; _key7++) {
        args[_key7 - 1] = arguments[_key7];
      }

      return (_rawClient$event9 = rawClient.event).unsubscribe.apply(_rawClient$event9, [ridToPresenceChannel(clientId)].concat(args));
    }
  };
};

exports.createClient = createClient;