"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.confTransformer = exports.getComParserEnv = exports.getBasicAssetParserEnv = exports.getUnitParserEnv = exports.getRecomposeParserEnv = exports.getUtilsParserEnv = void 0;

var _lodash = _interopRequireDefault(require("lodash.get"));

var _lodash2 = _interopRequireDefault(require("lodash.set"));

var _jsonTransformerJs = _interopRequireDefault(require("json-transformer-js"));

var _minimalLispParser = require("json-rule-processor/dist/minimal-lisp-parser");

var recompose = _interopRequireWildcard(require("recompose"));

var R = _interopRequireWildcard(require("ramda"));

var _unit = require("./unit");

var dataUtils = _interopRequireWildcard(require("./data-utils"));

var dmUtils = _interopRequireWildcard(require("./dm-utils"));

var uiUtils = _interopRequireWildcard(require("./ui-utils"));

var trUtils = _interopRequireWildcard(require("./transforms"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// import { withSub } from './withSub';
// import { withPresence } from './withPresence';
// import { withAsync } from './withAsync';
var getUtilsParserEnv = function getUtilsParserEnv() {
  return {
    'utils.tr': trUtils,
    'utils.data': dataUtils,
    'utils.dm': dmUtils,
    'utils.ui': uiUtils
  };
}; // withSub,
// withPresence,
// withReq: withAsync(req),
// connect,
// stringToElement,
// req,
// reqEntityConf,


exports.getUtilsParserEnv = getUtilsParserEnv;

var getRecomposeParserEnv = function getRecomposeParserEnv() {
  return trUtils.mapKeys(function (key) {
    return "Re.".concat(key);
  })(recompose);
};

exports.getRecomposeParserEnv = getRecomposeParserEnv;

var getUnitParserEnv = function getUnitParserEnv() {
  var unitSettings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var toUnit = function toUnit(unit, value) {
    var kind = (0, _unit.unitToKind)(unit);
    var targetUnit = unitSettings[kind];
    if (!targetUnit || Object.is(unit, targetUnit)) return value;
    return (0, _unit.convert)(unit, targetUnit, value);
  };

  return {
    unitSettings: unitSettings,
    unitLabel: function unitLabel(kind) {
      return (0, _unit.unitLabel)(kind, unitSettings);
    },
    toUnit: toUnit,
    unit: toUnit
  };
};

exports.getUnitParserEnv = getUnitParserEnv;

var getBasicAssetParserEnv = function getBasicAssetParserEnv() {
  var asset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _asset$channels = asset.channels,
      channels = _asset$channels === void 0 ? {} : _asset$channels;

  var fromAsset = function fromAsset(path, defaultValue) {
    return typeof path === 'string' ? (0, _lodash["default"])(asset, path, defaultValue) : R.pathOr(defaultValue, path)(asset);
  };

  return {
    fromAsset: fromAsset,
    assetChannel: function assetChannel(id) {
      return channels[id];
    }
  };
};

exports.getBasicAssetParserEnv = getBasicAssetParserEnv;

var getComParserEnv = function getComParserEnv(client) {
  return {
    pub: client.pub,
    pubChannel: client.pubChannel,
    rpc: client.rpc
  };
};

exports.getComParserEnv = getComParserEnv;

var confTransformer = function confTransformer(_ref) {
  var transforms = _ref.transforms,
      doLog = _ref.doLog,
      parserOptions = _objectWithoutProperties(_ref, ["transforms", "doLog"]);

  return function () {
    var vars = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var parser = (0, _minimalLispParser.functionalParserWithVars)(vars, _objectSpread({
      doLog: doLog
    }, parserOptions));
    var transformer = (0, _jsonTransformerJs["default"])({
      defaultLevel1Transform: function defaultLevel1Transform(v, k) {
        return (0, _lodash["default"])((0, _lodash2["default"])(vars, k, v), k);
      },
      transforms: _objectSpread({
        '%ml%': function ml(arr) {
          try {
            return parser.evaluate(arr);
          } catch (err) {
            if (doLog) console.error('miniMAL eval:', err);
            return undefined;
          }
        }
      }, transforms)
    });
    return transformer;
  };
};

exports.confTransformer = confTransformer;