"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Bars = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _chart = _interopRequireDefault(require("chart.js"));

var R = _interopRequireWildcard(require("ramda"));

var _transforms = require("i4-js-commons/dist/transforms");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  data: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  type: _propTypes["default"].string,
  options: _propTypes["default"].objectOf(_propTypes["default"].any),
  values: _propTypes["default"].arrayOf(_propTypes["default"].any),
  point: _propTypes["default"].objectOf(_propTypes["default"].any),
  points: _propTypes["default"].arrayOf(_propTypes["default"].object),
  length: _propTypes["default"].number,
  ttl: _propTypes["default"].number
};
var defaultProps = {
  style: {},
  data: {},
  values: undefined,
  type: 'bar',
  options: {},
  point: {},
  points: undefined,
  length: undefined,
  ttl: undefined
};
var chartColors = ['rgb(50, 152, 235)', 'rgb(255, 159, 64)', 'rgb(75, 185, 92)', 'rgb(153, 102, 255)', 'rgb(255, 99, 99)', 'rgb(255, 205, 86)', 'rgb(190, 90, 60)', 'rgb(231, 80, 200)', 'rgb(60, 203, 180)', 'rgb(255, 20, 0)', 'rgb(201, 203, 207)'];
var defaultCanvasStyle = {
  width: 300,
  height: 300
};
var commonOptions = {
  animation: {
    duration: 200
  },
  // animation: {
  //   duration: 0, // general animation time
  // },
  hover: {
    animationDuration: 0 // duration of animations when hovering an item

  },
  responsiveAnimationDuration: 0,
  // animation duration after a resize
  legend: {
    labels: {
      boxWidth: 6
    }
  }
};

var getDefaultDataset = function getDefaultDataset() {
  return {
    fill: false,
    backgroundColor: chartColors,
    borderColor: chartColors,
    borderWidth: 0
  };
};

var getDefaultOptions = function getDefaultOptions() {
  return _objectSpread({}, commonOptions, {
    legend: {
      display: false
    }
  });
};

var Bars = function Bars(_ref) {
  var style = _ref.style,
      type = _ref.type,
      data = _ref.data,
      options = _ref.options,
      point = _ref.point,
      ttl = _ref.ttl,
      rest = _objectWithoutProperties(_ref, ["style", "type", "data", "options", "point", "ttl"]);

  var canvasRef = (0, _react.useRef)(null);
  var chart = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    // console.log('Bars init:', type, data, options, point, ttl);
    if (!chart.current) {
      var chartData = R.clone(data);
      /* eslint-disable no-param-reassign */

      if ((0, _transforms.nilOrEmpty)(chartData)) chartData = {};
      if (!Array.isArray(chartData.datasets) || R.isEmpty(chartData.datasets)) chartData.datasets = [getDefaultDataset()];
      /* eslint-enable no-param-reassign */
      // data.datasets.forEach(fixDatasetStyle);

      chart.current = new _chart["default"](canvasRef.current, {
        type: type,
        data: chartData,
        options: R.mergeDeepLeft(options, getDefaultOptions())
      });
    }
  }, [data, options, type]);
  (0, _react.useEffect)(function () {
    var _datasetHandle$data;

    console.log('Bars useEffect point:', point);
    if ((0, _transforms.nilOrEmpty)(point)) return;
    var datasetHandle = chart.current.data.datasets[0];

    (_datasetHandle$data = datasetHandle.data).splice.apply(_datasetHandle$data, [0, datasetHandle.data.length].concat(_toConsumableArray(point.pl)));

    if ((0, _transforms.nilOrEmpty)(datasetHandle.labels)) datasetHandle.labels = _toConsumableArray(point.pl);
    chart.current.update();
  }, [point]);

  var canvasStyle = _objectSpread({}, defaultCanvasStyle, {}, style); // canvasStyle.minHeight = canvasStyle.height;


  return (0, _react.useMemo)(function () {
    /* eslint-disable react/jsx-props-no-spreading */
    return _react["default"].createElement("canvas", _extends({
      // id={chartId}
      ref: canvasRef,
      width: canvasStyle.width,
      height: canvasStyle.height,
      style: canvasStyle
    }, rest));
    /* eslint-enable react/jsx-props-no-spreading */
  }, [canvasStyle, rest]);
};

exports.Bars = Bars;
Bars.propTypes = propTypes;
Bars.defaultProps = defaultProps;