"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Chart = exports.fixDatasetStyle = exports.pointIntoChart = exports.adjustDatasetsToPayload = exports.getDefaultDataset = exports.commonOptions = exports.chartColors = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _chart = _interopRequireDefault(require("chart.js"));

var R = _interopRequireWildcard(require("ramda"));

var _subSeconds = _interopRequireDefault(require("date-fns/fp/subSeconds"));

var _transforms = require("../transforms");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import { generateString } from '../data-utils';
var defPointRadius = 1.3;
var chartColors = ['rgb(50, 152, 235)', 'rgb(255, 159, 64)', 'rgb(75, 185, 92)', 'rgb(153, 102, 255)', 'rgb(255, 99, 99)', 'rgb(255, 205, 86)', 'rgb(190, 90, 60)', 'rgb(231, 80, 200)', 'rgb(60, 203, 180)', 'rgb(255, 20, 0)', 'rgb(201, 203, 207)'];
exports.chartColors = chartColors;
var defaultCanvasStyle = {
  width: 300,
  height: 300
};
var commonOptions = {
  animation: {
    duration: 200
  },
  hover: {
    animationDuration: 0 // duration of animations when hovering an item

  },
  legend: {
    labels: {
      boxWidth: 6
    }
  },
  maintainAspectRatio: false,
  responsive: true,
  responsiveAnimationDuration: 0 // animation duration after a resize

};
exports.commonOptions = commonOptions;

var getDefaultDataset = function getDefaultDataset(idx) {
  var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
      _ref$colors = _ref.colors,
      colors = _ref$colors === void 0 ? chartColors : _ref$colors,
      borderWidth = _ref.borderWidth,
      _ref$pointRadius = _ref.pointRadius,
      pointRadius = _ref$pointRadius === void 0 ? defPointRadius : _ref$pointRadius,
      _ref$fill = _ref.fill,
      fill = _ref$fill === void 0 ? false : _ref$fill;

  return {
    fill: fill,
    label: "pl[".concat(idx, "]"),
    data: data,
    backgroundColor: colors[idx],
    borderColor: colors[idx],
    borderWidth: borderWidth,
    pointRadius: pointRadius,
    spanGaps: true
  };
};

exports.getDefaultDataset = getDefaultDataset;

var adjustDatasetsToPayload = function adjustDatasetsToPayload(datasets, payload, datasetOptions) {
  while (datasets.length < payload.length) {
    datasets.push(getDefaultDataset(datasets.length, R.repeat(null, datasets[0] ? datasets[0].data.length : 0), datasetOptions));
  }

  while (datasets.length > payload.length) {
    datasets.pop();
  }
};

exports.adjustDatasetsToPayload = adjustDatasetsToPayload;
var pointIntoChart = R.curry(function (chart, _ref2, point) {
  var length = _ref2.length,
      ttl = _ref2.ttl,
      datasetOptions = _ref2.datasetOptions;
  var x = point.x || point.ts || point.timestamp || point.time || new Date();
  var ys = point.payload || point.pl || point.data || [null]; // Add or remove datasets depending on number of ys:

  adjustDatasetsToPayload(chart.data.datasets, ys, datasetOptions); // Calculate if we should cut the tail

  var chronologicStart = (0, _transforms.nilOrEmpty)(chart.data.labels) || x > chart.data.labels[0];
  var remove = 0;

  if (ttl) {
    remove = R.findIndex(R.lt((0, _subSeconds["default"])(ttl)(x)))(chart.data.labels);
  } else if (length) {
    remove = 1;
    if (chronologicStart && chart.data.labels.length < length) remove = 0;
  }

  chart.data.labels.splice(0, remove);
  chart.data.labels.push(x);
  chart.data.datasets.forEach(function (ds, ix) {
    var val = ys[ix];
    ds.data.splice(0, remove);
    ds.data.push(val);
  });
});
exports.pointIntoChart = pointIntoChart;
var propTypes = {
  data: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  type: _propTypes["default"].string,
  options: _propTypes["default"].objectOf(_propTypes["default"].any),
  point: _propTypes["default"].objectOf(_propTypes["default"].any),
  points: _propTypes["default"].arrayOf(_propTypes["default"].object),
  length: _propTypes["default"].number,
  ttl: _propTypes["default"].number
};
var defaultProps = {
  style: {},
  data: undefined,
  type: 'line',
  options: {},
  point: {},
  points: undefined,
  length: undefined,
  ttl: undefined
};
var defaultOptions = {
  bar: _objectSpread({}, commonOptions),
  line: _objectSpread({}, commonOptions, {
    // tooltips: { enabled: false },
    scales: {
      xAxes: [{
        type: 'time',
        time: {
          parser: 'HH:mm:ss',
          tooltipFormat: 'D MMM HH:mm:ss',
          minUnit: 'second',
          displayFormats: {
            millisecond: 'mm:ss.SSS',
            second: 'HH:mm:ss',
            minute: 'HH:mm',
            hour: 'D HH:00'
          }
        },
        scaleLabel: {
          display: false // labelString: 'Date',

        }
      }],
      yAxes: [{
        scaleLabel: {
          display: false // labelString: 'value',

        }
      }]
    }
  })
};

var fixDatasetStyle = function fixDatasetStyle(datasetOptions) {
  return function (ds, ix) {
    /* eslint-disable no-param-reassign */
    R.mapObjIndexed(function (val, key) {
      ds[key] = ds[key] || val;
    })(getDefaultDataset(ix, ds.data, datasetOptions)); // if (!ds.backgroundColor) ds.backgroundColor = chartColors[ix];
    // if (!ds.borderColor) ds.borderColor = chartColors[ix];
    // if (!ds.pointRadius) ds.pointRadius = pointRadius;

    /* eslint-enable no-param-reassign */
  };
};

exports.fixDatasetStyle = fixDatasetStyle;
var defaultData = {};

var Chart = function Chart(_ref3) {
  var style = _ref3.style,
      type = _ref3.type,
      _ref3$data = _ref3.data,
      data = _ref3$data === void 0 ? defaultData : _ref3$data,
      options = _ref3.options,
      point = _ref3.point,
      points = _ref3.points,
      length = _ref3.length,
      ttl = _ref3.ttl,
      rest = _objectWithoutProperties(_ref3, ["style", "type", "data", "options", "point", "points", "length", "ttl"]);

  var canvasRef = (0, _react.useRef)(null);
  var chart = (0, _react.useRef)(null); // const chartId = useRef(generateString(8));

  (0, _react.useEffect)(function () {
    // console.log('Chart init:', type, data, options, point, points, length, ttl);
    if (!chart.current) {
      /* eslint-disable no-param-reassign */
      if ((0, _transforms.nilOrEmpty)(data.datasets)) data.datasets = [];
      /* eslint-enable no-param-reassign */

      var fixDS = fixDatasetStyle();
      data.datasets.forEach(fixDS);
      chart.current = new _chart["default"](canvasRef.current, {
        type: type,
        data: data,
        options: R.mergeDeepLeft(options, defaultOptions[type])
      });
    }
  }, []);
  (0, _react.useEffect)(function () {
    if ((0, _transforms.nilOrEmpty)(points)) return; // console.log('Chart useEffect points:', points);

    R.map(pointIntoChart(chart.current, {
      length: length,
      ttl: ttl
    }))(points);
    chart.current.update();
  }, [points]);
  (0, _react.useEffect)(function () {
    if ((0, _transforms.nilOrEmpty)(point)) return; // console.log('Chart useEffect point:', point);

    pointIntoChart(chart.current, {
      length: length || 10,
      ttl: ttl
    }, point);
    chart.current.update();
  }, [point]);

  var canvasStyle = _objectSpread({}, defaultCanvasStyle, {}, style); // canvasStyle.minHeight = canvasStyle.height;


  return (0, _react.useMemo)(function () {
    return _react["default"].createElement("canvas", _extends({
      // id={chartId}
      ref: canvasRef,
      width: canvasStyle.width,
      height: canvasStyle.height,
      style: canvasStyle
    }, rest));
  }, [chart.current]);
};

exports.Chart = Chart;
Chart.propTypes = propTypes;
Chart.defaultProps = defaultProps;