"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DebugText = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _get = _interopRequireDefault(require("lodash/fp/get"));

var _core = require("@material-ui/core");

var _uiUtils = require("../ui-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var font = 'consolas, courier new, monospace';
var useStyles = (0, _core.makeStyles)(function () {
  return {
    flexbox: {
      fontSize: '11px',
      fontFamily: font,
      textAlign: 'center'
    }
  };
});
var propTypes = {
  point: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  path: _propTypes["default"].string
};
var defaultProps = {
  path: '',
  point: undefined,
  style: {}
};

var DebugText = function DebugText(_ref) {
  var point = _ref.point,
      path = _ref.path,
      style = _ref.style;
  var classes = useStyles();
  return _react["default"].createElement("div", {
    style: _objectSpread({
      justifyContent: 'center',
      display: 'flex',
      flexDirection: 'column'
    }, style)
  }, _react["default"].createElement("div", {
    className: classes.flexbox
  }, (0, _uiUtils.dataToText)(path ? (0, _get["default"])(path, point) : point)));
};

exports.DebugText = DebugText;
DebugText.propTypes = propTypes;
DebugText.defaultProps = defaultProps;