"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Image = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _FlexIcon = require("./FlexIcon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useStyles = (0, _core.makeStyles)(function () {
  return {
    icon: {
      fontSize: 48 // color: ({ blackBackground: bb }) => (bb ? 'white' : 'black')

    },
    image: {
      // backgroundColor: ({ blackBackground: bb }) => {
      //   console.log({ bb });
      //   return bb ? 'black' : 'white';
      // },
      backgroundSize: 'contain',
      backgroundRepeat: 'no-repeat',
      backgroundPosition: 'center'
    }
  };
});
var propTypes = {
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  src: _propTypes["default"].string,

  /* eslint-disable react/no-unused-prop-types */
  blackBackground: _propTypes["default"].bool,

  /* eslint-enable react/no-unused-prop-types */
  forVideo: _propTypes["default"].bool
};

var Image = function Image(_ref) {
  var style = _ref.style,
      src = _ref.src,
      forVideo = _ref.forVideo,
      blackBackground = _ref.blackBackground;
  var classes = useStyles();

  if (!src) {
    return _react["default"].createElement(_FlexIcon.FlexIcon, {
      size: "xl",
      className: classes.icon,
      style: {
        color: blackBackground ? 'white' : 'black'
      }
    }, forVideo ? 'videocam_off' : 'mdi-image-off');
  }

  var urlIsh = src.startsWith('http') && src || (src.startsWith('data:') ? src : "data:jpeg;base64,".concat(src));
  return _react["default"].createElement("div", {
    className: classes.image,
    style: _objectSpread({
      backgroundImage: "url(".concat(urlIsh, ")"),
      backgroundColor: blackBackground ? 'black' : 'white'
    }, style || {})
  });
};

exports.Image = Image;
Image.propTypes = propTypes;