"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImageWithIndicator = void 0;

var _react = _interopRequireDefault(require("react"));

var _core = require("@material-ui/core");

var _Indicator = require("./Indicator");

var _Image = require("./Image");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// const useStyles = makeStyles(() => ({
//   grid: {
//     display: 'flex',
//     flexDirection: 'column',
//   },
//   image: {
//     display: 'flex',
//     justifyContent: 'center',
//     alignItems: 'center',
//     width: '100%',
//     flexGrow: 1,
//   },
//   bar: {
//     height: '48',
//     display: 'inline-flex',
//     flexDirection: 'row',
//     justifyContent: 'space-between',
//   },
// }));
var ImageWithIndicator = function ImageWithIndicator(_ref) {
  var style = _ref.style,
      _ref$label = _ref.label,
      label = _ref$label === void 0 ? 'Connection status' : _ref$label,
      src = _ref.src,
      indicatorProps = _objectWithoutProperties(_ref, ["style", "label", "src"]);

  // const classes = useStyles();
  return _react["default"].createElement(_core.Box, {
    display: "flex",
    width: "100%",
    flexDirection: "column",
    alignItems: "stretch",
    style: style
  }, _react["default"].createElement(_core.Box, {
    flexGrow: 1,
    alignSelf: "center",
    display: "flex",
    alignItems: "center"
  }, _react["default"].createElement(_Image.Image, {
    src: src,
    style: {
      width: 300,
      height: '100%'
    }
  })), _react["default"].createElement(_core.Divider, null), _react["default"].createElement(_core.Box, {
    p: 1,
    height: 48,
    display: "flex",
    justifyContent: "space-between",
    alignItems: "center"
  }, _react["default"].createElement(_core.Typography, {
    variant: "subheading1"
  }, label), _react["default"].createElement(_Indicator.Indicator, _extends({
    size: 32
  }, indicatorProps))));
};

exports.ImageWithIndicator = ImageWithIndicator;