"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Table = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _Table = _interopRequireDefault(require("@material-ui/core/Table"));

var _TableBody = _interopRequireDefault(require("@material-ui/core/TableBody"));

var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _uiUtils = require("../ui-utils");

var _transforms = require("../transforms");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    tableContainer: {
      overflowY: 'auto',
      height: '100%'
    },
    wordBreak: {
      wordBreak: 'break-all'
    },
    lesserRightPadding: {
      paddingRight: theme.spacing(1)
    }
  };
});
var propTypes = {
  data: _propTypes["default"].objectOf(_propTypes["default"].any),
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  point: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  style: {},
  data: {},
  point: undefined
};

var Table = function Table(_ref) {
  var style = _ref.style,
      data = _ref.data,
      point = _ref.point;
  var classes = useStyles();
  var theData = point || data;
  if ((0, _transforms.nilOrEmpty)(theData)) return null;
  return _react["default"].createElement("div", {
    style: style,
    className: classes.tableContainer
  }, _react["default"].createElement(_Divider["default"], null), _react["default"].createElement(_Table["default"], null, _react["default"].createElement(_TableBody["default"], null, Object.keys(theData).map(function (key) {
    return _react["default"].createElement(_TableRow["default"], {
      key: key
    }, _react["default"].createElement(_TableCell["default"], {
      className: classes.lesserRightPadding
    }, key), _react["default"].createElement(_TableCell["default"], {
      className: classes.wordBreak
    }, (0, _uiUtils.prettyPrint)(theData[key])));
  }))));
};

exports.Table = Table;
Table.propTypes = propTypes;
Table.defaultProps = defaultProps;